//#include <windows.h>
//#include <stdio.h>
#include "FTD2XX.H"

//////////////////////////////////////////////////////////////////////////

#ifdef __cplusplus
extern "C" {
#endif

/************************************************************************/
/* Structures                                                           */
/************************************************************************/

typedef struct _RF60x_HELLO_ANSWER_
{
	BYTE	bDeviceType;
	BYTE	bDeviceModificaton;
	WORD	wDeviceSerial;
	WORD	wDeviceMaxDistance;
	WORD	wDeviceRange;
} RF60xHELLOANSWER, *LPRF60xHELLOANSWER;

//////////////////////////////////////////////////////////////////////////

/************************************************************************/
/* Definitions                                                          */
/************************************************************************/

///////////////////////////////////////////////////////// Address / Length ////////////////
#define	RF60x_PARAMETER_POWER_STATE						((0x00) | ((0x01) << 8))
#define	RF60x_PARAMETER_ANALOG_OUT						((0x01) | ((0x01) << 8))
#define	RF60x_PARAMETER_SAMPLE_AND_SYNC					((0x02) | ((0x01) << 8))
#define	RF60x_PARAMETER_NETWORK_ADDRESS					((0x03) | ((0x01) << 8))
#define	RF60x_PARAMETER_BAUDRATE						((0x04) | ((0x01) << 8))
#define	RF60x_PARAMETER_LASER_BRIGHT					((0x05) | ((0x01) << 8))
#define	RF60x_PARAMETER_AVERAGE_COUNT					((0x06) | ((0x01) << 8))
#define	RF60x_PARAMETER_SAMPLING_PERIOD					((0x08) | ((0x02) << 8))
#define RF60x_PARAMETER_ACCUMULATION_TIME				((0x0A) | ((0x02) << 8))
#define	RF60x_PARAMETER_BEGIN_ANALOG_RANGE				((0x0C) | ((0x02) << 8))
#define	RF60x_PARAMETER_END_ANALOG_RANGE				((0x0E) | ((0x02) << 8))
#define	RF60x_PARAMETER_RESULT_DELAY_TIME				((0x10) | ((0x01) << 8))
#define	RF60x_PARAMETER_ZERO_POINT_VALUE				((0x17) | ((0x02) << 8))
#define RF60x_PARAMETER_CAN_SPEED						((0x20) | ((0x01) << 8))
#define RF60x_PARAMETER_CAN_STANDARD_ID					((0x22) | ((0x02) << 8))
#define RF60x_PARAMETER_CAN_EXTENDED_ID					((0x24) | ((0x04) << 8))
#define RF60x_PARAMETER_CAN_ID							((0x28) | ((0x01) << 8))

//////////////////////////////////////////////////////////////////////////

/************************************************************************/
/* Functions                                                            */
/************************************************************************/

/************************************************************************/
/* RS-232 functions                                                     */
/************************************************************************/

BOOL	RF60x_OpenPort(
			LPCSTR					lpPort_Name, 
			DWORD					dwSpeed, 
			HANDLE *				lpHandle 
			);

BOOL    RF60x_ClosePort(
			HANDLE					hHandle
			);

BOOL    RF60x_HelloCmd(
			HANDLE					hCOM, 
			BYTE					bAddress,
			LPRF60xHELLOANSWER		lprfHelloAnswer 
			);

BOOL	RF60x_ReadParameter(		
			HANDLE					hCOM, 
			BYTE					bAddress, 
			WORD					wParameter,
			DWORD *					lpdwValue 
			);

BOOL	RF60x_WriteParameter(		
			HANDLE					hCOM, 
			BYTE					bAddress, 
			WORD					wParameter,
			DWORD					dwValue 
			);

BOOL	RF60x_ReadCustomParameter(		
			HANDLE					hCOM, 
			BYTE					bAddress, 
			BYTE					bParameterAddress,
			BYTE					bParameterSize,
			void *					lpValue 
			);

BOOL	RF60x_WriteCustomParameter(		
			HANDLE					hCOM, 
			BYTE					bAddress, 
			BYTE					bParameterAddress,
			BYTE					bParameterSize,
			void *					lpValue 
			);

BOOL	RF60x_FlushToFlash(		
			HANDLE					hCOM, 
			BYTE					bAddress
			);

BOOL	RF60x_RestoreFromFlash(		
			HANDLE					hCOM, 
			BYTE					bAddress
			);

BOOL	RF60x_LockResult(		
			HANDLE					hCOM, 
			BYTE					bAddress
			);

BOOL	RF60x_Measure(	
			HANDLE					hCOM, 
			BYTE					bAddress, 
			USHORT *				lpusValue 
			);

BOOL	RF60x_StartStream(	
			HANDLE					hCOM, 
			BYTE					bAddress
			);

BOOL	RF60x_StopStream(	
			HANDLE					hCOM, 
			BYTE					bAddress
			);

BOOL	RF60x_GetStreamMeasure(	
			HANDLE					hCOM, 
			USHORT *				lpusValue 
			);

BOOL	RF60x_CustomCmd(	
			HANDLE					hCOM, 
			char *					pcInData, 
			DWORD					dwInSize, 
			char *					pcOutData, 
			DWORD *					pdwOutSize
			);

/************************************************************************/
/* FTDI (RS-485) functions                                              */
/************************************************************************/

BOOL	RF60x_FTDI_OpenPort(		
			LPCSTR					lpPort_Name, 
			DWORD					dwSpeed, 
			FT_HANDLE *				lpftHandle 
			);

BOOL	RF60x_FTDI_ClosePort( 
			FT_HANDLE				hftHandle 
			);

BOOL	RF60x_FTDI_HelloCmd(	
			FT_HANDLE				hCOM, 
			BYTE					bAddress, 
			LPRF60xHELLOANSWER		lprfHelloAnswer 
			);

BOOL	RF60x_FTDI_ReadParameter(		
			FT_HANDLE				hCOM, 
			BYTE					bAddress, 
			WORD					wParameter,
			DWORD *					lpdwValue 
			);

BOOL	RF60x_FTDI_WriteParameter(		
			FT_HANDLE				hCOM, 
			BYTE					bAddress, 
			WORD					wParameter,
			DWORD					dwValue 
			);

BOOL	RF60x_FTDI_ReadCustomParameter(		
			FT_HANDLE				hCOM, 
			BYTE					bAddress, 
			BYTE					bParameterAddress,
			BYTE					bParameterSize,
			void *					lpValue 
			);

BOOL	RF60x_FTDI_WriteCustomParameter(		
			FT_HANDLE				hCOM, 
			BYTE					bAddress, 
			BYTE					bParameterAddress,
			BYTE					bParameterSize,
			void *					lpValue 
			);

BOOL	RF60x_FTDI_FlushToFlash(		
			FT_HANDLE				hCOM, 
			BYTE					bAddress
			);

BOOL	RF60x_FTDI_RestoreFromFlash(		
			FT_HANDLE				hCOM, 
			BYTE					bAddress
			);

BOOL	RF60x_FTDI_LockResult(		
			FT_HANDLE				hCOM, 
			BYTE					bAddress
			);

BOOL	RF60x_FTDI_Measure( 
			FT_HANDLE				hCOM, 
			BYTE					bAddress, 
			DWORD *					pdwData 
			);

BOOL	RF60x_FTDI_StartStream(	
			FT_HANDLE				hCOM, 
			BYTE					bAddress
			);

BOOL	RF60x_FTDI_StopStream(	
			HANDLE					hCOM, 
			BYTE					bAddress
			);

BOOL	RF60x_FTDI_GetStreamMeasure(	
			FT_HANDLE				hCOM, 
			USHORT *				lpusValue 
			);

BOOL	RF60x_FTDI_CustomCmd( 
			FT_HANDLE				hCOM, 
			char *					pcInData, 
			DWORD					dwInSize, 
			char *					pcOutData, 
			DWORD *					pdwOutSize
			);

#ifdef __cplusplus
}
#endif

//////////////////////////////////////////////////////////////////////////