//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#pragma link "rf60x.lib"
#include "rf60x_main_lt.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TRF60xTestForm *RF60xTestForm;

////////////////////////

DWORD   dwCOMSpeed[5] = {9600, 19200, 38400, 57600, 115200};

////////////////////////

HANDLE          	       hRF60x			= INVALID_HANDLE_VALUE;
DWORD			       dwValue;
USHORT			       usMeasured;
RF60xHELLOANSWER	       hlans;
HMODULE                        hDLL                     = NULL;

////////////////////////


//---------------------------------------------------------------------------
__fastcall TRF60xTestForm::TRF60xTestForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TRF60xTestForm::ConnectButtonClick(TObject *Sender)
{
        DWORD dwCOMSpeed;

          if ( hRF60x == INVALID_HANDLE_VALUE)
          {
              memset(&hlans, 0x00, sizeof(RF60xHELLOANSWER));

              switch(COMSpeedComboBox->ItemIndex)
              {
                case 0:
                 dwCOMSpeed = CBR_9600;
                 break;
                case 1:
                 dwCOMSpeed = CBR_19200;
                 break;
                case 2:
                 dwCOMSpeed = CBR_38400;
                 break;
                case 3:
                 dwCOMSpeed = CBR_57600;
                 break;
                case 4:
                 dwCOMSpeed = CBR_115200;
                 break;
                default:
                 break;
              }

              if (!RF60x_OpenPort(COMNameEdit->Text.c_str(), dwCOMSpeed, &hRF60x))
                return;

              if (RF60x_HelloCmd( hRF60x, 1, &hlans ))
	        {
                        DeviceInfoLabel->Caption = "Device type: " + IntToStr(hlans.bDeviceType);
                        DevModLabel->Caption     = "Device modification: " + IntToStr(hlans.bDeviceModificaton);
                        DevSerialLabel->Caption  = "Device serial: " + IntToStr(hlans.wDeviceSerial);
                        DevMaxDistLabel->Caption = "Device max dist: " + IntToStr(hlans.wDeviceMaxDistance);
                        DevRangeLabel->Caption   = "Device range: " + IntToStr(hlans.wDeviceRange);
                        ConnectButton->Caption = "Disconnect";
                } else {
                        Application->MessageBox("Error: Check your COM settings...","Error",MB_ICONWARNING);
                        ConnectButton->Caption = "Connect";
                        RF60x_ClosePort( hRF60x );
                        hRF60x                  = INVALID_HANDLE_VALUE;
                        return;
                }
          } else {
                RF60x_ClosePort( hRF60x );
                hRF60x                  = INVALID_HANDLE_VALUE;
                ConnectButton->Caption  = "Connect";
          }
}
//---------------------------------------------------------------------------

void __fastcall TRF60xTestForm::FormDestroy(TObject *Sender)
{
        if ( hRF60x != INVALID_HANDLE_VALUE)
        {
                RF60x_ClosePort( hRF60x );
                hRF60x = INVALID_HANDLE_VALUE;
        }

}
//---------------------------------------------------------------------------

void __fastcall TRF60xTestForm::MeasureButtonClick(TObject *Sender)
{
        AnsiString as;
        USHORT     usMeasuredVal;

        if ( hRF60x == INVALID_HANDLE_VALUE)
          return;

        if (RF60x_Measure( hRF60x, DevCSpinEdit->Value, &usMeasuredVal))
        {
                as.sprintf("%.02f mm", (usMeasuredVal * hlans.wDeviceRange) / 16384.0f);
                MeasureLabel->Caption = as;
        }
}
//---------------------------------------------------------------------------

void __fastcall TRF60xTestForm::LockResultButtonClick(TObject *Sender)
{
        if ( hRF60x == INVALID_HANDLE_VALUE)
          return;

        RF60x_LockResult( hRF60x, DevCSpinEdit->Value );
}
//---------------------------------------------------------------------------

void __fastcall TRF60xTestForm::StartStreamButtonClick(TObject *Sender)
{
        if ( hRF60x == INVALID_HANDLE_VALUE)
          return;

        RF60x_StartStream( hRF60x, DevCSpinEdit->Value );

        MeasureTimer->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TRF60xTestForm::StopStreamButtonClick(TObject *Sender)
{
        if ( hRF60x == INVALID_HANDLE_VALUE)
          return;

        RF60x_StopStream( hRF60x, DevCSpinEdit->Value );

        MeasureTimer->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TRF60xTestForm::MeasureTimerTimer(TObject *Sender)
{
        AnsiString as;
        USHORT     usMeasuredVal;

        if ( hRF60x == INVALID_HANDLE_VALUE)
          return;

        if (RF60x_GetStreamMeasure( hRF60x, &usMeasuredVal))
        {
                as.sprintf("%.02f mm", (usMeasuredVal * hlans.wDeviceRange) / 16384.0f);
                MeasureLabel->Caption = as;
        }
}
//---------------------------------------------------------------------------

