// TestDLL.cpp : Defines the entry point for the console application.
//

#include <stdio.h>
#include <conio.h>
#include <windows.h>
#include "RF60x.h"

int main(int argc, char* argv[])
{

	HANDLE				hRF60x			= INVALID_HANDLE_VALUE;
	DWORD				dwValue;
	USHORT				usMeasured;
	RF60xHELLOANSWER	hlans;


	memset(&hlans, 0x00, sizeof(RF60xHELLOANSWER));

	RF60x_OpenPort("COM2:", CBR_9600, &hRF60x);


	if (RF60x_HelloCmd( hRF60x, 1, &hlans ))
	{

		printf("Dev modify\t: %d\r\nDev type\t: %d\r\nDev max dist\t: %d\r\nDev range\t: %d\r\nDev serial\t: %d\r\n",		
						hlans.bDeviceModificaton, 
						hlans.bDeviceType, 
						hlans.wDeviceMaxDistance, 
						hlans.wDeviceRange, 
						hlans.wDeviceSerial
						);

		RF60x_ReadParameter( hRF60x, 1, RF60x_PARAMETER_POWER_STATE, &dwValue );

		printf("Power state\t: %d\r\n", dwValue);


		RF60x_ReadParameter( hRF60x, 1, RF60x_PARAMETER_ANALOG_OUT, &dwValue );
		
		printf("Analog out\t: %d\r\n", dwValue);


		RF60x_ReadParameter( hRF60x, 1, RF60x_PARAMETER_SAMPLE_AND_SYNC, &dwValue );
		
		printf("Sample & sync\t: 0x%X\r\n", dwValue);


		RF60x_ReadParameter( hRF60x, 1, RF60x_PARAMETER_NETWORK_ADDRESS, &dwValue );
		
		printf("Network address\t: %d\r\n", dwValue);


		RF60x_ReadParameter( hRF60x, 1, RF60x_PARAMETER_BAUDRATE, &dwValue );
		
		printf("Baudrate\t: %d\r\n", dwValue);


		RF60x_ReadParameter( hRF60x, 1, RF60x_PARAMETER_LASER_BRIGHT, &dwValue );
		
		printf("Laser bright\t: %d\r\n", dwValue);
		

		RF60x_ReadParameter( hRF60x, 1, RF60x_PARAMETER_AVERAGE_COUNT, &dwValue );
		
		printf("Average count\t: %d\r\n", dwValue);


		RF60x_ReadParameter( hRF60x, 1, RF60x_PARAMETER_SAMPLING_PERIOD, &dwValue );
		
		printf("Sampling period\t: %d\r\n", dwValue);


		RF60x_ReadParameter( hRF60x, 1, RF60x_PARAMETER_ACCUMULATION_TIME, &dwValue );
		
		printf("Accum time\t: %d\r\n", dwValue);


		RF60x_ReadParameter( hRF60x, 1, RF60x_PARAMETER_BEGIN_ANALOG_RANGE, &dwValue );
		
		printf("Beg analog\t: %d\r\n", dwValue);


		RF60x_ReadParameter( hRF60x, 1, RF60x_PARAMETER_END_ANALOG_RANGE, &dwValue );
		
		printf("End analog\t: %d\r\n", dwValue);


		RF60x_ReadParameter( hRF60x, 1, RF60x_PARAMETER_RESULT_DELAY_TIME, &dwValue );
		
		printf("Res delay\t: %d\r\n", dwValue);


		RF60x_ReadParameter( hRF60x, 1, RF60x_PARAMETER_ZERO_POINT_VALUE, &dwValue );
		
		printf("Zero point\t: %d\r\n", dwValue);


		RF60x_ReadParameter( hRF60x, 1, RF60x_PARAMETER_CAN_SPEED, &dwValue );
		
		printf("CAN speed\t: %d\r\n", dwValue);


		RF60x_ReadParameter( hRF60x, 1, RF60x_PARAMETER_CAN_STANDARD_ID, &dwValue );
		
		printf("CAN standID\t: 0x%04X\r\n", dwValue);


		RF60x_ReadParameter( hRF60x, 1, RF60x_PARAMETER_CAN_EXTENDED_ID, &dwValue );
		
		printf("CAN extID\t: 0x%08X\r\n", dwValue);


		RF60x_ReadParameter( hRF60x, 1, RF60x_PARAMETER_CAN_ID, &dwValue );
		
		printf("CAN ID	\t: %d\r\n", dwValue);


		RF60x_Measure( hRF60x, 1, &usMeasured);

		printf("Measure	\t: %d\r\n", usMeasured);



		// Your settings! //////////////////////////////////////////////////////////////////////////
		
		RF60x_WriteParameter( hRF60x, 0x01, RF60x_PARAMETER_SAMPLE_AND_SYNC, 0 );
		RF60x_WriteParameter( hRF60x, 0x01, RF60x_PARAMETER_SAMPLING_PERIOD, 5000 );

		RF60x_StartStream( hRF60x, 0x01 );

		// Run while ESC is pressed ////////////////////////////////////////////////////////////////

		while(!GetAsyncKeyState(VK_ESCAPE))
		{
			if (!RF60x_GetStreamMeasure( hRF60x, &usMeasured ))
			{
				printf("Error!\r\n", usMeasured);
				RF60x_StopStream( hRF60x, 0x01 );
				break;

			}
			printf("Measure	\t: %d\r\n", usMeasured);
		}

		RF60x_StopStream( hRF60x, 0x01 );


	} else printf("rs232 error!\r\n");


	RF60x_ClosePort( hRF60x );

	_getch();

	return 0;
}

